#include <iomanip>
#include <iostream>
#include <cmath>
#define f(x,y) ((x)+cos((y)/sqrt(10)))
void euler(float x, float y, float h, float xn) {
    std::cout<<"Метод Ейлера:"<<std::endl<<"i  x_i\ty_i"<<std::endl<<"0  "<<x<<'\t'<<y<<std::endl;
    unsigned short i=0;
    while (x < xn) {
        i++;
        y += h * f(x, y);
        x += h;
        std::cout<<i<<' ';
        if(log10(i)<1)std::cout<<' ';
        std::cout<<x<<'\t'<<y<<std::endl;
    }
}
void rungeKutta(float x, float y, float h, float xn) {
    std::cout<<"Метод Рунге-Кутта 4-го порядку:"<<std::endl<<"i  x_i\ty_i\tk1_i\tk2_i\tk3_i\tk4_i"<<std::endl<<"0  "<<x<<'\t'<<y<<std::endl<<std::setprecision(5);
    unsigned short i=0;
    while (x < xn) {
        i++;
        float k1 = h * f(x, y);
        float k2 = h * f(x + h/2, y + k1/2);
        float k3 = h * f(x + h/2, y + k2/2);
        float k4 = h * f(x + h, y + k3);
        y +=(k1 + 2*k2 + 2*k3 + k4)/6;
        x += h;
        std::cout<<i<<' ';
        if(log10(i)<1)std::cout<<' ';
        std::cout<<x<<'\t'<<y<<'\t'<<k1<<'\t'<<k2<<'\t'<<k3<<'\t'<<k4<<std::endl;
    }
}
void adams(float x, float y, float h, float xn) {
    std::cout<<"Метод Адамса:"<<std::endl<<"i  x\ty"<<std::endl<<"0  "<<x<<'\t'<<y<<std::endl;
    float y_prev = y, y_new, x_prev = x;
    x += h;
    y += h * f(x_prev, y_prev);
    std::cout<<"1  "<<x<<'\t'<<y<<std::endl;
    unsigned short i=1;
    while (x < xn) {
        i++;
        y_new = y + (h / 2) * (3 * f(x, y) - f(x_prev, y_prev));
        x_prev = x;
        x = x + h;
        y_prev = y;
        y = y_new;
        std::cout<<i<<' ';
        if(log10(i)<1)std::cout<<' ';
        std::cout<<x<<'\t'<<y<<std::endl;
    }
}
int main() {
    float x0 = 0.6, y0 = 0.8, xn = 1.6, h = 0.1;
    euler(x0, y0, h, xn);
    rungeKutta(x0, y0, h, xn);
    adams(x0, y0, h, xn);
    return 0;
}
